#pragma semicolon 1

#include <possessed_weapons>
#include <sourcemod>
#include <sdktools_stringtables>
#include <sdktools_sound>

public Plugin:myinfo = 
{
	name	= "Possessed Weapons (Credits Giver)",
	author	= "wS (World-Source.Ru)",
	version = "1.0"
};

new g_ReqPlayers;
new String:g_sMsg[256], String:g_sSound[150];
new g_Credits_kill[2], g_Credits_knife[2], g_Credits_headshot[2];
new g_Credits_defuse, g_Credits_explode, g_Credits_hostage, g_Credits_win, g_Credits_team;

public OnPluginStart()
{
	///
	new Handle:kv = CreateKeyValues("credits_giver");

	if (!FileToKeyValues(kv, "cfg/possessed_weapons/modules/credits_giver.txt"))
		SetFailState("Error in cfg/possessed_weapons/modules/credits_giver.txt");

	// таймер - выдача кредитов каждые 'x' мин
	decl credits; new timer_min = KvGetNum(kv, "timer");
	if (timer_min > 0 && (credits = KvGetNum(kv, "timer_credits")) > 0)
	{
		// звук
		KvGetString(kv, "timer_sound", g_sSound, 150);
		if (TrimString(g_sSound) < 5)
			g_sSound[0] = '\0';

		// сообщение
		KvGetString(kv, "timer_msg", g_sMsg, 256);
		if (TrimString(g_sMsg) > 0)
		{
			ReplaceString(g_sMsg, 256, "#", "\x07", false);
			ReplaceString(g_sMsg, 256, "{green}", "\x04", false);
			ReplaceString(g_sMsg, 256, "{lightgreen}", "\x03", false);
			ReplaceString(g_sMsg, 256, "{darkgreen}", "\x05", false);
			ReplaceString(g_sMsg, 256, "{default}", "\x01", false);
		}
		else
			g_sMsg[0] = '\0';

		CreateTimer(float(timer_min * 60), CreditsTimer, credits, TIMER_REPEAT);
	}
	else
	{
		g_sSound[0]	= '\0';
		g_sMsg[0]	= '\0';
	}

	if ((g_ReqPlayers = KvGetNum(kv, "players")) > MaxClients)
		g_ReqPlayers = MaxClients;

	g_Credits_kill[0]				= KvGetNum(kv, "credits_kill+");
	g_Credits_kill[1]				= KvGetNum(kv, "credits_kill-");
	g_Credits_knife[0]				= KvGetNum(kv, "credits_knife+");
	g_Credits_knife[1]				= KvGetNum(kv, "credits_knife-");
	g_Credits_headshot[0]			= KvGetNum(kv, "credits_headshot+");
	g_Credits_headshot[1]			= KvGetNum(kv, "credits_headshot-");
	g_Credits_defuse				= KvGetNum(kv, "credits_defuse");
	g_Credits_explode				= KvGetNum(kv, "credits_explode");
	g_Credits_hostage				= KvGetNum(kv, "credits_hostage");
	g_Credits_win					= KvGetNum(kv, "credits_win");
	g_Credits_team					= KvGetNum(kv, "credits_team");

	CloseHandle(kv);
	///

	HookEvent("player_death",		player_death,		EventHookMode_Post);
	HookEvent("bomb_exploded",		bomb_exploded,		EventHookMode_Post);
	HookEvent("bomb_defused",		bomb_defused,		EventHookMode_Post);
	HookEvent("hostage_rescued",	hostage_rescued,	EventHookMode_Post);
	HookEvent("round_end",			round_end,			EventHookMode_Post);
}

public Action:CreditsTimer(Handle:timer, any:credits)
{
	if (!Enabled())
		return Plugin_Continue;

	new bool:given = false;

	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && wS_TeamAccess(GetClientTeam(i)) && PW_AddCredits(i, credits))
			given = true;
	}

	if (given)
	{
		if (g_sMsg[0] != '\0') PrintToChatAll("\x01%s", g_sMsg);
		if (g_sSound[0] != '\0') EmitSoundToAll(g_sSound[6]);
	}

	return Plugin_Continue;
}

public OnMapStart()
{
	if (g_sSound[0] != '\0')
	{
		AddFileToDownloadsTable(g_sSound);
		PrecacheSound(g_sSound[6], true);
	}
}


///


public player_death(Handle:event, const String:name[], bool:silent)
{
	if (!Enabled())
		return;

	new killer		= GetClientOfUserId(GetEventInt(event, "attacker"));
	if (killer		< 1)
		return;

	new victim		= GetClientOfUserId(GetEventInt(event, "userid"));
	new killer_team	= GetClientTeam(killer);
	new victim_team	= GetClientTeam(victim);

	if (killer_team == victim_team)
		return;

	if (GetEventBool(event, "headshot"))
	{
		if (wS_TeamAccess(killer_team))		wS_TryGiveCredits(killer, g_Credits_headshot[0]);
		if (wS_TeamAccess(victim_team))		wS_TryTakeCredits(victim, g_Credits_headshot[1]);
	}
	else
	{
		decl String:Item[10];
		GetEventString(event, "weapon", Item, 10);

		if (strcmp(Item, "knife", false) == 0)
		{
			if (wS_TeamAccess(killer_team))	wS_TryGiveCredits(killer, g_Credits_knife[0]);
			if (wS_TeamAccess(victim_team))	wS_TryTakeCredits(victim, g_Credits_knife[1]);
		}
		else
		{
			if (wS_TeamAccess(killer_team))	wS_TryGiveCredits(killer, g_Credits_kill[0]);
			if (wS_TeamAccess(victim_team))	wS_TryTakeCredits(victim, g_Credits_kill[1]);
		}
	}
}

public bomb_exploded(Handle:event, const String:name[], bool:silent)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (client > 0 && Enabled()) wS_TryGiveCredits(client, g_Credits_explode, true);
}

public bomb_defused(Handle:event, const String:name[], bool:silent)
{
	if (Enabled()) wS_TryGiveCredits(GetClientOfUserId(GetEventInt(event, "userid")), g_Credits_defuse, true);
}

public hostage_rescued(Handle:event, const String:name[], bool:silent)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (client > 0 && Enabled()) wS_TryGiveCredits(client, g_Credits_hostage, true);
}

public round_end(Handle:event, const String:name[], bool:silent)
{
	new winner = GetEventInt(event, "winner");
	if (1 < winner < 4 && g_Credits_win > 0 && wS_TeamAccess(winner) && Enabled())
	{
		for (new i = 1; i <= MaxClients; i++)
		{
			if (IsClientInGame(i) && GetClientTeam(i) == winner)
				PW_AddCredits(i, g_Credits_win);
		}
	}
}


///


stock wS_TryGiveCredits(client, const credits, bool:bCheckTeam = false)
{
	if (credits > 0 && !(bCheckTeam && !wS_TeamAccess(GetClientTeam(client))))
		PW_AddCredits(client, credits);
}

stock wS_TryTakeCredits(client, const credits)
{
	if (credits > 0)
	{
		new cr = PW_GetCredits(client);
		if (cr > 0)
		{
			cr -= credits;
			if (cr < 0) cr = 0;
			PW_SetCredits(client, cr);
		}
	}
}

stock bool:Enabled()
{
	return g_ReqPlayers < 1 || GetClientCount() >= g_ReqPlayers;
}

stock bool:wS_TeamAccess(team)
{
	return team == g_Credits_team || g_Credits_team == 1;
}